{% extends 'inventory/base.html' %}
{% load crispy_forms_tags %}

{% block title %} | Inventory {% endblock %}

{% block content %}
    <h1 class="m-3 text-center">Import from Digi-Key</h1>

    <div class="container-fluid">
        <div class="row">
            <div class="col-md">
                <div class="card m-1">
                    <div class="card-header">
                        <h5>Lookup Parts</h5>
                    </div>
                    <form method="GET" class="m-3">
                        {% csrf_token %}
                        {{ form | crispy }}
                        <input type="submit" class="btn btn-primary" value="Lookup Parts"/>
                    </form>
                </div>
            </div>
            {% if parts|length > 0 %}
                <div class="col-md">
                    <div class="card m-1">
                        <div class="card-header">
                            <h5>Imported Properties</h5>
                        </div>
                        <div class="list-group list-group-flush">
                            {% for property in properties %}
                                <div class="list-group-item">
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text" style="min-width: 8em">{{ property.name }}</span>
                                        </div>

                                        <select id="{{ property.id }}_type" class="custom-select" style="width: 8em;">
                                            <option value="none">None</option>
                                            <option value="constant">Constant</option>
                                            <option value="digikey">Digi-Key</option>
                                        </select>
                                        <select id="{{ property.id }}_digikey" class="custom-select" style="width: 8em;"
                                                hidden>
                                            {% for digikey_property in digikey_properties %}
                                                <option value="{{ digikey_property }}">{{ digikey_property }}</option>
                                            {% endfor %}
                                        </select>
                                        <input id="{{ property.id }}_constant" type="text" placeholder="Value"
                                               class="form-control" style="width: 8em" hidden/>
                                        <div class="input-group-append">
                                            {% if property.unit == None %}
                                                <span class="input-group-text"></span>
                                            {% else %}
                                                <span class="input-group-text">{{ property.unit }}</span>
                                            {% endif %}
                                        </div>
                                    </div>
                                </div>
                            {% endfor %}
                        </div>
                    </div>
                </div>
            {% endif %}
        </div>
    </div>

    {% if parts|length > 0 %}
        <div class="table-responsive mt-3">
            <table class="table table-hover">
                <thead class="thead-light">
                <tr>
                    <th class="text-wrap"><i class="fas fa-file"></i></th>
                    <th class="text-wrap">Mfg. Part #</th>
                    <th class="text-wrap text-right">Mfg.</th>
                    <th class="text-wrap text-right">Digi-Key Part #</th>
                    <th class="text-wrap text-right">Description</th>
                    <th class="text-wrap text-right">Cost</th>
                    {% for property in properties %}
                        <th class="text-right">{{ property.name }}</th>
                    {% endfor %}
                </tr>
                </thead>
                <tbody>
                {% for part in parts %}
                    {% with id=forloop.counter0 %}
                        <tr class="{% if part.existing_part != None %} table-warning {% else %} table-success {% endif %}">
                            <td id="{{ id }}_datasheet" class="text-right align-middle">
                                <a href="{{ part.datasheet }}"><i class="fas fa-file"></i></a>
                            </td>
                            <td id="{{ id }}_manufacturer_part_number" class="align-middle">{{ part.manufacturer_part_number }}</td>
                            <td id="{{ id }}_manufacturer" class="text-right align-middle">{{ part.manufacturer }}</td>
                            <td id="{{ id }}_digikey_part_number" class="text-right align-middle">
                                <a href="{{ part.digikey_url }}">
                                    {{ part.digikey_part_number }}
                                </a>
                            </td>
                            <td id="{{ id }}_description" class="text-right align-middle">{{ part.description }}</td>
                            <td id="{{ id }}_price" class="text-right align-middle">${{ part.price }}</td>
                            {% for property in properties %}
                                <td id="{{ id }}_{{ property.id }}" class="text-right align-middle"></td>
                            {% endfor %}
                        </tr>
                    {% endwith %}
                {% endfor %}
                </tbody>
            </table>
        </div>

        <form method="post">
            {% csrf_token %}
            <input id="category" name="category" value="" type="hidden"/>
            <input id="data" name="data" value="" type="hidden"/>
            <input type="submit" class="btn btn-primary" value="Import Parts"/>
        </form>
    {% else %}
        <p class="text-center mt-3">No parts found</p>
    {% endif %}

    <script>

        let generate_parts = function () {

            let parts = [];

            let part_property = function (id, metric, digikey_properties) {
                let type_select = document.getElementById(id + "_type");
                let digikey_select = document.getElementById(id + "_digikey");
                let constant_field = document.getElementById(id + "_constant");

                let selected = type_select.value;

                if (selected === "none") {
                    return null;
                } else if (selected === "digikey") {
                    let digikey_property = digikey_properties[digikey_select.value];
                    if (digikey_property !== null && digikey_property !== undefined) {
                        if (metric) {
                            return digikey_property['metric'];
                        } else {
                            return digikey_property['raw'];
                        }
                    } else {
                        return null
                    }
                } else if (selected === "constant") {
                    return constant_field.value;
                } else {
                    return "??";
                }
            }

            {% for part in parts %} {
                let digikey_properties = {
                    {% for name, metric_value, raw_value in part.properties %}
                        {% autoescape off %}
                            "{{ name }}": {"metric": "{{ metric_value }}", "raw": '{{ raw_value }}'},
                        {% endautoescape %}
                    {% endfor %}
                };

                let properties = {
                    {% for property in properties %}
                        "{{ property.id }}": part_property("{{ property.id }}", {{ property.metric | lower }}, digikey_properties),
                    {% endfor %}
                };

                let existing_properties = {
                    {% if part.existing_part != None %}
                        {% for part_property in part.existing_part.partproperty_set.all %}
                            "{{ part_property.property.id }}": "{{ part_property.rendered }}",
                        {% endfor %}
                    {% endif %}
                };

                console.log(existing_properties)

                let part = {
                    "manufacturer": "{{ part.manufacturer }}",
                    "manufacturer_part_number": "{{ part.manufacturer_part_number }}",
                    "digikey_part_number": "{{ part.digikey_part_number }}",
                    "digikey_url": "{{ part.digikey_url }}",
                    "datasheet": "{{ part.datasheet }}",
                    "description": "{{ part.description }}",
                    "price": "{{ part.price }}",
                    "digikey_properties": digikey_properties,
                    "properties": properties,
                    "existing_properties": existing_properties,
                }
                parts.push(part);
            } {% endfor %}

            return parts;
        };

        let update_table = function (parts) {
            {% for part in parts %} {
                {% with id=forloop.counter0 %}
                    let part = parts[{{ id }}];
                    let properties = part['properties']
                    let existing_properties = part['existing_properties']
                    console.log(existing_properties)
                    {% for property in properties %} {
                        let property = properties["{{ property.id }}"];
                        let existing_property = existing_properties["{{ property.id }}"]
                        console.log("{{ property.id }}: " + existing_property);
                        let cell = document.getElementById("{{ id }}_{{ property.id }}")
                        if (property !== undefined && property !== null) {
                            cell.classList.add('border')
                            cell.classList.add('border-success');
                            cell.classList.remove('text-success');
                            {% if property.unit == None %}
                                cell.innerText = property;
                            {% else %}
                                cell.innerText = property + "{{ property.unit }}";
                            {% endif %}
                        } else if (existing_property !== undefined && existing_property !== null) {
                            cell.classList.remove('border')
                            cell.classList.remove('border-success');
                            cell.classList.remove('text-success');
                            cell.innerText = existing_property;
                        } else {
                            cell.classList.remove('border')
                            cell.classList.remove('border-success');
                            cell.classList.add('text-success');
                            cell.innerText = "―";
                        }
                    } {% endfor %}
                {% endwith %}
            } {% endfor %}
        };

        property_type_select_onchange = function (id) {
            return function () {
                let type_select = document.getElementById(id + "_type");
                let digikey_select = document.getElementById(id + "_digikey");
                let constant_field = document.getElementById(id + "_constant");

                let selected = type_select.value;

                if (selected === "none") {
                    digikey_select.hidden = true;
                    constant_field.hidden = true;
                } else if (selected === "digikey") {
                    digikey_select.hidden = false;
                    constant_field.hidden = true;
                } else if (selected === "constant") {
                    digikey_select.hidden = true;
                    constant_field.hidden = false;
                }
            };
        }

        let onupdate = function () {
            let parts = generate_parts();
            update_table(parts);
            document.getElementById("data").value = JSON.stringify(parts)
            document.getElementById("category").value = document.getElementById('id_category').value
        }

        {% for property in properties %}
            document.getElementById("{{ property.id }}_type").onchange = function () {
                property_type_select_onchange("{{ property.id }}")();
                onupdate();
            };

            document.getElementById("{{ property.id }}_digikey").onchange = onupdate;

            document.getElementById("{{ property.id }}_constant").oninput = onupdate;

            property_type_select_onchange("{{ property.id }}")();
        {% endfor %}

        onupdate();
    </script>
{% endblock %}
